# Generated via
#  `rails generate hyrax:work CrcDataset`
module Hyrax
  # Generated form for CrcDataset
  class CrcDatasetForm < Hyrax::Forms::WorkForm
    self.model_class = ::CrcDataset
    self.terms -= [
      # Fields not interested in
      :creator, :contributor, :rights_notes, :rights_statement,
      :access_right, :date_created, :identifier, :based_near, :related_url, :source,
      # Fields interested in, but removing to re-order
      :title, :alternative_title, :resource_type, :description, :abstract, :keyword, :license,
      :publisher, :subject, :language,
      # Fields that are not displayed
      # :import_url, :date_modified, :date_uploaded, :depositor, :bibliographic_citation, :label, :relative_path
    ]

    self.terms += [
      # Adding all fields in order of display in form
      :parent_work_id,
      :crc_work_type,
      :title,
      :experiment_description,
      :complex_person,
      :crc_resource_type,
      :coverage,
      :approval_number,
      :extra_information,
      :complex_date,
      :publisher,
      :language,
      :complex_funding_reference,
      :description,
      :subject,
      :keyword,
      :resource_type,
      :complex_relation,
      :software_version,
      :license
    ]

    self.required_fields = [
      # Adding all required fields in order of display in form
      :title
    ]

    def primary_terms
      [
        # Fields to be displayed above fold
        :title,
        :experiment_description,
        :complex_person,
        :crc_resource_type,
        :coverage,
        :keyword,
        :license,
        :approval_number,
        :extra_information
      ]
    end

    def required_fields
      [
        :title,
        :experiment_description,
        :complex_person,
        :crc_resource_type,
        :coverage,
        :keyword,
        :license
      ]
    end

    protected

    def self.permitted_date_params
      [:id,
       :_destroy,
       {
         date: [],
         description: []
       }
      ]
    end

    def self.permitted_person_params
      [:id,
       :_destroy,
       :corresponding_author,
       :display_order,
       {
         last_name: [],
         first_name: [],
         name: [],
         role: [],
         orcid: [],
         affiliation: [],
       }
      ]
    end

    def self.permitted_relation_params
      [:id,
       :_destroy,
       {
         title: [],
         url: [],
         relationship: []
       }
      ]
    end

    def self.permitted_fundref_params
      [:id,
       :_destroy,
       {
         funder_identifier: [],
         funder_name: [],
         award_number: [],
         award_uri: [],
         award_title: []
       }
      ]
    end

    def self.build_permitted_params
      permitted = super
      permitted << :doi
      permitted << :license
      permitted << :modality
      permitted << :crc_resource_type
      permitted << :coverage
      permitted << :approval_number
      permitted << :extra_information
      permitted << :software_version
      permitted << :parent_work_id
      permitted << :crc_work_type
      permitted << :folder_name
      permitted << :experiment_description
      permitted << { complex_date_attributes: permitted_date_params }
      permitted << { complex_person_attributes: permitted_person_params }
      permitted << { complex_relation_attributes: permitted_relation_params }
      permitted << { complex_funding_reference_attributes: permitted_fundref_params }
    end
  end
end
